﻿using Infragistics.Win;
using Infragistics.Win.UltraMessageBox;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace CAS_143946_N9Y6Z9
{
    public partial class Form1 : Form
    {
        DataTable dt = GridData.GetSampleData();
        bool isRowChanged = false;
        int prevActiveRowIndex = 0;
        List<object> ls = null;
        bool isDialogResNo = false;

        public Form1()
        {
            InitializeComponent();

            this.ultraGrid1.DataSource = dt;
        }

        private void ultraGrid1_BeforeRowDeactivate(object sender, CancelEventArgs e)
        {
            if (isRowChanged)
            {
                DialogResult result = MessageBox.Show("Save the changes?", "caption", MessageBoxButtons.YesNo);

                if (result == DialogResult.Yes)
                {
                    isRowChanged = !isRowChanged;
                    e.Cancel = true;
                }
                else
                {
                    isDialogResNo = true;
                }
            }
        }

        private void ultraGrid1_BeforeCellUpdate(object sender, BeforeCellUpdateEventArgs e)
        {
            isRowChanged = e.Cell.Row.DataChanged;
            prevActiveRowIndex = e.Cell.Row.Index;
        }


        private void ultraGrid1_ClickCell(object sender, ClickCellEventArgs e)
        {
            CallClickCell(e.Cell);
        }

        private void ultraGrid1_BeforeRowUpdate(object sender, CancelableRowEventArgs e)
        {
            if (isRowChanged)
            {
                e.Cancel = true;
            }
        }

        private void CallClickCell(UltraGridCell cell)
        {
            if (isRowChanged && isDialogResNo)
            {
                var bla = cell.Row.Index;
                ls = new List<object>();
                foreach (var cells in ultraGrid1.Rows[prevActiveRowIndex].Cells)
                {
                    ls.Add(cells.Value);
                }

                this.ultraLabel1.Text = ls[0].ToString();
                this.ultraLabel2.Text = ls[1].ToString();
                this.ultraLabel3.Text = ls[2].ToString();

                isRowChanged = !isRowChanged;

                isDialogResNo = false;
                this.ultraGrid1.Rows[cell.Row.Index].Activated = true;
            }
        }
    }
}
